<?php
// $Id: calendar-mini.tpl.php,v 1.1.2.7 2010/11/21 13:19:37 karens Exp $
/**
 * @file
 * Template to display a view as a mini calendar month.
 *
 * @see template_preprocess_calendar_mini.
 *
 * $day_names: An array of the day of week names for the table header.
 * $rows: An array of data for each day of the week.
 * $view: The view.
 * $min_date_formatted: The minimum date for this calendar in the format YYYY-MM-DD HH:MM:SS.
 * $max_date_formatted: The maximum date for this calendar in the format YYYY-MM-DD HH:MM:SS.
 *
 * $show_title: If the title should be displayed. Normally false since the title is incorporated
 *   into the navigation, but sometimes needed, like in the year view of mini calendars.
 *
 */
//dsm('Display: '. $display_type .': '. $min_date_formatted .' to '. $max_date_formatted);
?>
<div class="calendar-calendar"><div class="month-view">
<?php if ($view->date_info->show_title): ?>
  <?php print theme('date_navigation', $view); ?>
<?php endif; ?>
<table class="mini">
  <thead>
    <tr>
      <?php foreach ($day_names as $cell): ?>
        <th class="<?php print $cell['class']; ?>">
          <?php print $cell['data']; ?>
        </th>
      <?php endforeach; ?>
    </tr>
  </thead>
  <tbody>
    <?php foreach ((array) $rows as $row): ?>
      <tr>
        <?php foreach ($row as $cell): ?>
          <td class="<?php print $cell['class']; ?> <?php print $cell['id']; ?>">
            <?php print $cell['data']; ?>
          </td>
        <?php endforeach; ?>
      </tr>
    <?php endforeach; ?>
  </tbody>
</table>
</div></div><?php $storm_contrib_icons_path = '/'.drupal_get_path('module', 'storm_contrib') .'/icons';?>
<div class="stormtimetracking-extension-calendar-frame">
<table class="stormtimetracking-extension-calendar-table">
      <tr>
          <td class="stormtimetracking-extension-calendar-legend-icon"><img src="<?php print($storm_contrib_icons_path.'/calendar-today.jpg');?>"></td><td class="stormtimetracking-extension-calendar-legend-text"><?php print(t('today'));?></td>
          <td class="stormtimetracking-extension-calendar-legend-icon"><img src="<?php print($storm_contrib_icons_path.'/calendar-not-enough.jpg');?>"></td><td class="stormtimetracking-extension-calendar-legend-text"><?php print(t('not enough trackings'));?></td>
      </tr>
      <tr>
          <td class="stormtimetracking-extension-calendar-legend-icon"><img src="<?php print($storm_contrib_icons_path.'/calendar-selected.jpg');?>"></td><td class="stormtimetracking-extension-calendar-legend-text"><?php print(t('selected'));?></td>
          <td class="stormtimetracking-extension-calendar-legend-icon"><img src="<?php print($storm_contrib_icons_path.'/calendar-no-trackings.jpg');?>"></td><td class="stormtimetracking-extension-calendar-legend-text"><?php print(t('no trackings'));?></td>
      </tr>
</table>
</div>